{
  "version": "2.0",
  "metadata": {
    "apiVersion": "2023-06-05",
    "endpointPrefix": "bedrock-agent",
    "jsonVersion": "1.1",
    "protocol": "rest-json",
    "serviceFullName": "Agents for Amazon Bedrock",
    "serviceId": "Bedrock Agent",
    "signatureVersion": "v4",
    "signingName": "bedrock",
    "uid": "bedrock-agent-2023-06-05"
  },
  "operations": {
    "AssociateAgentKnowledgeBase": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "knowledgeBaseId",
          "description"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "knowledgeBaseId": {},
          "description": {},
          "knowledgeBaseState": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentKnowledgeBase"
        ],
        "members": {
          "agentKnowledgeBase": {
            "shape": "S7"
          }
        }
      },
      "idempotent": true
    },
    "CreateAgent": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentName",
          "agentResourceRoleArn"
        ],
        "members": {
          "agentName": {},
          "clientToken": {
            "idempotencyToken": true
          },
          "instruction": {
            "shape": "Sd"
          },
          "foundationModel": {},
          "description": {},
          "idleSessionTTLInSeconds": {
            "type": "integer"
          },
          "agentResourceRoleArn": {},
          "customerEncryptionKeyArn": {},
          "tags": {
            "shape": "Si"
          },
          "promptOverrideConfiguration": {
            "shape": "Sl"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agent"
        ],
        "members": {
          "agent": {
            "shape": "S11"
          }
        }
      },
      "idempotent": true
    },
    "CreateAgentActionGroup": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "actionGroupName"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "actionGroupName": {},
          "clientToken": {
            "idempotencyToken": true
          },
          "description": {},
          "parentActionGroupSignature": {},
          "actionGroupExecutor": {
            "shape": "S1a"
          },
          "apiSchema": {
            "shape": "S1b"
          },
          "actionGroupState": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentActionGroup"
        ],
        "members": {
          "agentActionGroup": {
            "shape": "S1i"
          }
        }
      },
      "idempotent": true
    },
    "CreateAgentAlias": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentaliases/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentAliasName"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentAliasName": {},
          "clientToken": {
            "idempotencyToken": true
          },
          "description": {},
          "routingConfiguration": {
            "shape": "S1k"
          },
          "tags": {
            "shape": "Si"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentAlias"
        ],
        "members": {
          "agentAlias": {
            "shape": "S1n"
          }
        }
      },
      "idempotent": true
    },
    "CreateDataSource": {
      "http": {
        "method": "PUT",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "name",
          "dataSourceConfiguration"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "clientToken": {
            "idempotencyToken": true
          },
          "name": {},
          "description": {},
          "dataSourceConfiguration": {
            "shape": "S1u"
          },
          "serverSideEncryptionConfiguration": {
            "shape": "S20"
          },
          "vectorIngestionConfiguration": {
            "shape": "S21"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "dataSource"
        ],
        "members": {
          "dataSource": {
            "shape": "S28"
          }
        }
      },
      "idempotent": true
    },
    "CreateKnowledgeBase": {
      "http": {
        "method": "PUT",
        "requestUri": "/knowledgebases/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "name",
          "roleArn",
          "knowledgeBaseConfiguration",
          "storageConfiguration"
        ],
        "members": {
          "clientToken": {
            "idempotencyToken": true
          },
          "name": {},
          "description": {},
          "roleArn": {},
          "knowledgeBaseConfiguration": {
            "shape": "S2c"
          },
          "storageConfiguration": {
            "shape": "S2g"
          },
          "tags": {
            "shape": "Si"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBase"
        ],
        "members": {
          "knowledgeBase": {
            "shape": "S33"
          }
        }
      },
      "idempotent": true
    },
    "DeleteAgent": {
      "http": {
        "method": "DELETE",
        "requestUri": "/agents/{agentId}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "skipResourceInUseCheck": {
            "location": "querystring",
            "locationName": "skipResourceInUseCheck",
            "type": "boolean"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentId",
          "agentStatus"
        ],
        "members": {
          "agentId": {},
          "agentStatus": {}
        }
      },
      "idempotent": true
    },
    "DeleteAgentActionGroup": {
      "http": {
        "method": "DELETE",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
        "responseCode": 204
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "actionGroupId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "actionGroupId": {
            "location": "uri",
            "locationName": "actionGroupId"
          },
          "skipResourceInUseCheck": {
            "location": "querystring",
            "locationName": "skipResourceInUseCheck",
            "type": "boolean"
          }
        }
      },
      "output": {
        "type": "structure",
        "members": {}
      },
      "idempotent": true
    },
    "DeleteAgentAlias": {
      "http": {
        "method": "DELETE",
        "requestUri": "/agents/{agentId}/agentaliases/{agentAliasId}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentAliasId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentAliasId": {
            "location": "uri",
            "locationName": "agentAliasId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentId",
          "agentAliasId",
          "agentAliasStatus"
        ],
        "members": {
          "agentId": {},
          "agentAliasId": {},
          "agentAliasStatus": {}
        }
      },
      "idempotent": true
    },
    "DeleteAgentVersion": {
      "http": {
        "method": "DELETE",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "skipResourceInUseCheck": {
            "location": "querystring",
            "locationName": "skipResourceInUseCheck",
            "type": "boolean"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "agentStatus"
        ],
        "members": {
          "agentId": {},
          "agentVersion": {},
          "agentStatus": {}
        }
      },
      "idempotent": true
    },
    "DeleteDataSource": {
      "http": {
        "method": "DELETE",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId",
          "status"
        ],
        "members": {
          "knowledgeBaseId": {},
          "dataSourceId": {},
          "status": {}
        }
      },
      "idempotent": true
    },
    "DeleteKnowledgeBase": {
      "http": {
        "method": "DELETE",
        "requestUri": "/knowledgebases/{knowledgeBaseId}",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "status"
        ],
        "members": {
          "knowledgeBaseId": {},
          "status": {}
        }
      },
      "idempotent": true
    },
    "DisassociateAgentKnowledgeBase": {
      "http": {
        "method": "DELETE",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
        "responseCode": 204
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "knowledgeBaseId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          }
        }
      },
      "output": {
        "type": "structure",
        "members": {}
      },
      "idempotent": true
    },
    "GetAgent": {
      "http": {
        "method": "GET",
        "requestUri": "/agents/{agentId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agent"
        ],
        "members": {
          "agent": {
            "shape": "S11"
          }
        }
      }
    },
    "GetAgentActionGroup": {
      "http": {
        "method": "GET",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "actionGroupId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "actionGroupId": {
            "location": "uri",
            "locationName": "actionGroupId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentActionGroup"
        ],
        "members": {
          "agentActionGroup": {
            "shape": "S1i"
          }
        }
      }
    },
    "GetAgentAlias": {
      "http": {
        "method": "GET",
        "requestUri": "/agents/{agentId}/agentaliases/{agentAliasId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentAliasId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentAliasId": {
            "location": "uri",
            "locationName": "agentAliasId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentAlias"
        ],
        "members": {
          "agentAlias": {
            "shape": "S1n"
          }
        }
      }
    },
    "GetAgentKnowledgeBase": {
      "http": {
        "method": "GET",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "knowledgeBaseId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentKnowledgeBase"
        ],
        "members": {
          "agentKnowledgeBase": {
            "shape": "S7"
          }
        }
      }
    },
    "GetAgentVersion": {
      "http": {
        "method": "GET",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentVersion"
        ],
        "members": {
          "agentVersion": {
            "type": "structure",
            "required": [
              "agentId",
              "agentName",
              "agentArn",
              "version",
              "agentStatus",
              "idleSessionTTLInSeconds",
              "agentResourceRoleArn",
              "createdAt",
              "updatedAt"
            ],
            "members": {
              "agentId": {},
              "agentName": {},
              "agentArn": {},
              "version": {},
              "instruction": {
                "shape": "Sd"
              },
              "agentStatus": {},
              "foundationModel": {},
              "description": {},
              "idleSessionTTLInSeconds": {
                "type": "integer"
              },
              "agentResourceRoleArn": {},
              "customerEncryptionKeyArn": {},
              "createdAt": {
                "shape": "S9"
              },
              "updatedAt": {
                "shape": "S9"
              },
              "failureReasons": {
                "shape": "S14"
              },
              "recommendedActions": {
                "shape": "S16"
              },
              "promptOverrideConfiguration": {
                "shape": "Sl"
              }
            }
          }
        }
      }
    },
    "GetDataSource": {
      "http": {
        "method": "GET",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "dataSource"
        ],
        "members": {
          "dataSource": {
            "shape": "S28"
          }
        }
      }
    },
    "GetIngestionJob": {
      "http": {
        "method": "GET",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/{ingestionJobId}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId",
          "ingestionJobId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          },
          "ingestionJobId": {
            "location": "uri",
            "locationName": "ingestionJobId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "ingestionJob"
        ],
        "members": {
          "ingestionJob": {
            "shape": "S41"
          }
        }
      }
    },
    "GetKnowledgeBase": {
      "http": {
        "method": "GET",
        "requestUri": "/knowledgebases/{knowledgeBaseId}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBase"
        ],
        "members": {
          "knowledgeBase": {
            "shape": "S33"
          }
        }
      }
    },
    "ListAgentActionGroups": {
      "http": {
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "actionGroupSummaries"
        ],
        "members": {
          "actionGroupSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "actionGroupId",
                "actionGroupName",
                "actionGroupState",
                "updatedAt"
              ],
              "members": {
                "actionGroupId": {},
                "actionGroupName": {},
                "actionGroupState": {},
                "description": {},
                "updatedAt": {
                  "shape": "S9"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListAgentAliases": {
      "http": {
        "requestUri": "/agents/{agentId}/agentaliases/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentAliasSummaries"
        ],
        "members": {
          "agentAliasSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "agentAliasId",
                "agentAliasName",
                "agentAliasStatus",
                "createdAt",
                "updatedAt"
              ],
              "members": {
                "agentAliasId": {},
                "agentAliasName": {},
                "description": {},
                "routingConfiguration": {
                  "shape": "S1k"
                },
                "agentAliasStatus": {},
                "createdAt": {
                  "shape": "S9"
                },
                "updatedAt": {
                  "shape": "S9"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListAgentKnowledgeBases": {
      "http": {
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentKnowledgeBaseSummaries"
        ],
        "members": {
          "agentKnowledgeBaseSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "knowledgeBaseId",
                "knowledgeBaseState",
                "updatedAt"
              ],
              "members": {
                "knowledgeBaseId": {},
                "description": {},
                "knowledgeBaseState": {},
                "updatedAt": {
                  "shape": "S9"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListAgentVersions": {
      "http": {
        "requestUri": "/agents/{agentId}/agentversions/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentVersionSummaries"
        ],
        "members": {
          "agentVersionSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "agentName",
                "agentStatus",
                "agentVersion",
                "createdAt",
                "updatedAt"
              ],
              "members": {
                "agentName": {},
                "agentStatus": {},
                "agentVersion": {},
                "createdAt": {
                  "shape": "S9"
                },
                "updatedAt": {
                  "shape": "S9"
                },
                "description": {}
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListAgents": {
      "http": {
        "requestUri": "/agents/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "members": {
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentSummaries"
        ],
        "members": {
          "agentSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "agentId",
                "agentName",
                "agentStatus",
                "updatedAt"
              ],
              "members": {
                "agentId": {},
                "agentName": {},
                "agentStatus": {},
                "description": {},
                "updatedAt": {
                  "shape": "S9"
                },
                "latestAgentVersion": {}
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListDataSources": {
      "http": {
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "dataSourceSummaries"
        ],
        "members": {
          "dataSourceSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "knowledgeBaseId",
                "dataSourceId",
                "name",
                "status",
                "updatedAt"
              ],
              "members": {
                "knowledgeBaseId": {},
                "dataSourceId": {},
                "name": {},
                "status": {},
                "description": {},
                "updatedAt": {
                  "shape": "S9"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListIngestionJobs": {
      "http": {
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          },
          "filters": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "attribute",
                "operator",
                "values"
              ],
              "members": {
                "attribute": {},
                "operator": {},
                "values": {
                  "type": "list",
                  "member": {}
                }
              }
            }
          },
          "sortBy": {
            "type": "structure",
            "required": [
              "attribute",
              "order"
            ],
            "members": {
              "attribute": {},
              "order": {}
            }
          },
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "ingestionJobSummaries"
        ],
        "members": {
          "ingestionJobSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "knowledgeBaseId",
                "dataSourceId",
                "ingestionJobId",
                "status",
                "startedAt",
                "updatedAt"
              ],
              "members": {
                "knowledgeBaseId": {},
                "dataSourceId": {},
                "ingestionJobId": {},
                "description": {},
                "status": {},
                "startedAt": {
                  "shape": "S9"
                },
                "updatedAt": {
                  "shape": "S9"
                },
                "statistics": {
                  "shape": "S43"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListKnowledgeBases": {
      "http": {
        "requestUri": "/knowledgebases/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "members": {
          "maxResults": {
            "type": "integer"
          },
          "nextToken": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBaseSummaries"
        ],
        "members": {
          "knowledgeBaseSummaries": {
            "type": "list",
            "member": {
              "type": "structure",
              "required": [
                "knowledgeBaseId",
                "name",
                "status",
                "updatedAt"
              ],
              "members": {
                "knowledgeBaseId": {},
                "name": {},
                "description": {},
                "status": {},
                "updatedAt": {
                  "shape": "S9"
                }
              }
            }
          },
          "nextToken": {}
        }
      }
    },
    "ListTagsForResource": {
      "http": {
        "method": "GET",
        "requestUri": "/tags/{resourceArn}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "resourceArn"
        ],
        "members": {
          "resourceArn": {
            "location": "uri",
            "locationName": "resourceArn"
          }
        }
      },
      "output": {
        "type": "structure",
        "members": {
          "tags": {
            "shape": "Si"
          }
        }
      }
    },
    "PrepareAgent": {
      "http": {
        "requestUri": "/agents/{agentId}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentId",
          "agentStatus",
          "agentVersion",
          "preparedAt"
        ],
        "members": {
          "agentId": {},
          "agentStatus": {},
          "agentVersion": {},
          "preparedAt": {
            "shape": "S9"
          }
        }
      }
    },
    "StartIngestionJob": {
      "http": {
        "method": "PUT",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          },
          "clientToken": {
            "idempotencyToken": true
          },
          "description": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "ingestionJob"
        ],
        "members": {
          "ingestionJob": {
            "shape": "S41"
          }
        }
      },
      "idempotent": true
    },
    "TagResource": {
      "http": {
        "requestUri": "/tags/{resourceArn}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "resourceArn",
          "tags"
        ],
        "members": {
          "resourceArn": {
            "location": "uri",
            "locationName": "resourceArn"
          },
          "tags": {
            "shape": "Si"
          }
        }
      },
      "output": {
        "type": "structure",
        "members": {}
      }
    },
    "UntagResource": {
      "http": {
        "method": "DELETE",
        "requestUri": "/tags/{resourceArn}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "resourceArn",
          "tagKeys"
        ],
        "members": {
          "resourceArn": {
            "location": "uri",
            "locationName": "resourceArn"
          },
          "tagKeys": {
            "location": "querystring",
            "locationName": "tagKeys",
            "type": "list",
            "member": {}
          }
        }
      },
      "output": {
        "type": "structure",
        "members": {}
      },
      "idempotent": true
    },
    "UpdateAgent": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentName",
          "agentResourceRoleArn"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentName": {},
          "instruction": {
            "shape": "Sd"
          },
          "foundationModel": {},
          "description": {},
          "idleSessionTTLInSeconds": {
            "type": "integer"
          },
          "agentResourceRoleArn": {},
          "customerEncryptionKeyArn": {},
          "promptOverrideConfiguration": {
            "shape": "Sl"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agent"
        ],
        "members": {
          "agent": {
            "shape": "S11"
          }
        }
      },
      "idempotent": true
    },
    "UpdateAgentActionGroup": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "actionGroupId",
          "actionGroupName"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "actionGroupId": {
            "location": "uri",
            "locationName": "actionGroupId"
          },
          "actionGroupName": {},
          "description": {},
          "parentActionGroupSignature": {},
          "actionGroupExecutor": {
            "shape": "S1a"
          },
          "actionGroupState": {},
          "apiSchema": {
            "shape": "S1b"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentActionGroup"
        ],
        "members": {
          "agentActionGroup": {
            "shape": "S1i"
          }
        }
      },
      "idempotent": true
    },
    "UpdateAgentAlias": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentaliases/{agentAliasId}/",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentAliasId",
          "agentAliasName"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentAliasId": {
            "location": "uri",
            "locationName": "agentAliasId"
          },
          "agentAliasName": {},
          "description": {},
          "routingConfiguration": {
            "shape": "S1k"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentAlias"
        ],
        "members": {
          "agentAlias": {
            "shape": "S1n"
          }
        }
      },
      "idempotent": true
    },
    "UpdateAgentKnowledgeBase": {
      "http": {
        "method": "PUT",
        "requestUri": "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "agentId",
          "agentVersion",
          "knowledgeBaseId"
        ],
        "members": {
          "agentId": {
            "location": "uri",
            "locationName": "agentId"
          },
          "agentVersion": {
            "location": "uri",
            "locationName": "agentVersion"
          },
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "description": {},
          "knowledgeBaseState": {}
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "agentKnowledgeBase"
        ],
        "members": {
          "agentKnowledgeBase": {
            "shape": "S7"
          }
        }
      },
      "idempotent": true
    },
    "UpdateDataSource": {
      "http": {
        "method": "PUT",
        "requestUri": "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
        "responseCode": 200
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "dataSourceId",
          "name",
          "dataSourceConfiguration"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "dataSourceId": {
            "location": "uri",
            "locationName": "dataSourceId"
          },
          "name": {},
          "description": {},
          "dataSourceConfiguration": {
            "shape": "S1u"
          },
          "serverSideEncryptionConfiguration": {
            "shape": "S20"
          },
          "vectorIngestionConfiguration": {
            "shape": "S21"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "dataSource"
        ],
        "members": {
          "dataSource": {
            "shape": "S28"
          }
        }
      },
      "idempotent": true
    },
    "UpdateKnowledgeBase": {
      "http": {
        "method": "PUT",
        "requestUri": "/knowledgebases/{knowledgeBaseId}",
        "responseCode": 202
      },
      "input": {
        "type": "structure",
        "required": [
          "knowledgeBaseId",
          "name",
          "roleArn",
          "knowledgeBaseConfiguration",
          "storageConfiguration"
        ],
        "members": {
          "knowledgeBaseId": {
            "location": "uri",
            "locationName": "knowledgeBaseId"
          },
          "name": {},
          "description": {},
          "roleArn": {},
          "knowledgeBaseConfiguration": {
            "shape": "S2c"
          },
          "storageConfiguration": {
            "shape": "S2g"
          }
        }
      },
      "output": {
        "type": "structure",
        "required": [
          "knowledgeBase"
        ],
        "members": {
          "knowledgeBase": {
            "shape": "S33"
          }
        }
      },
      "idempotent": true
    }
  },
  "shapes": {
    "S7": {
      "type": "structure",
      "required": [
        "agentId",
        "agentVersion",
        "knowledgeBaseId",
        "description",
        "createdAt",
        "updatedAt",
        "knowledgeBaseState"
      ],
      "members": {
        "agentId": {},
        "agentVersion": {},
        "knowledgeBaseId": {},
        "description": {},
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        },
        "knowledgeBaseState": {}
      }
    },
    "S9": {
      "type": "timestamp",
      "timestampFormat": "iso8601"
    },
    "Sd": {
      "type": "string",
      "sensitive": true
    },
    "Si": {
      "type": "map",
      "key": {},
      "value": {}
    },
    "Sl": {
      "type": "structure",
      "required": [
        "promptConfigurations"
      ],
      "members": {
        "promptConfigurations": {
          "type": "list",
          "member": {
            "type": "structure",
            "members": {
              "promptType": {},
              "promptCreationMode": {},
              "promptState": {},
              "basePromptTemplate": {},
              "inferenceConfiguration": {
                "type": "structure",
                "members": {
                  "temperature": {
                    "type": "float"
                  },
                  "topP": {
                    "type": "float"
                  },
                  "topK": {
                    "type": "integer"
                  },
                  "maximumLength": {
                    "type": "integer"
                  },
                  "stopSequences": {
                    "type": "list",
                    "member": {}
                  }
                }
              },
              "parserMode": {}
            }
          }
        },
        "overrideLambda": {}
      },
      "sensitive": true
    },
    "S11": {
      "type": "structure",
      "required": [
        "agentId",
        "agentName",
        "agentArn",
        "agentVersion",
        "agentStatus",
        "idleSessionTTLInSeconds",
        "agentResourceRoleArn",
        "createdAt",
        "updatedAt"
      ],
      "members": {
        "agentId": {},
        "agentName": {},
        "agentArn": {},
        "agentVersion": {},
        "clientToken": {},
        "instruction": {
          "shape": "Sd"
        },
        "agentStatus": {},
        "foundationModel": {},
        "description": {},
        "idleSessionTTLInSeconds": {
          "type": "integer"
        },
        "agentResourceRoleArn": {},
        "customerEncryptionKeyArn": {},
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        },
        "preparedAt": {
          "shape": "S9"
        },
        "failureReasons": {
          "shape": "S14"
        },
        "recommendedActions": {
          "shape": "S16"
        },
        "promptOverrideConfiguration": {
          "shape": "Sl"
        }
      }
    },
    "S14": {
      "type": "list",
      "member": {}
    },
    "S16": {
      "type": "list",
      "member": {}
    },
    "S1a": {
      "type": "structure",
      "members": {
        "lambda": {}
      },
      "union": true
    },
    "S1b": {
      "type": "structure",
      "members": {
        "s3": {
          "type": "structure",
          "members": {
            "s3BucketName": {},
            "s3ObjectKey": {}
          }
        },
        "payload": {
          "type": "string",
          "sensitive": true
        }
      },
      "union": true
    },
    "S1i": {
      "type": "structure",
      "required": [
        "agentId",
        "agentVersion",
        "actionGroupId",
        "actionGroupName",
        "createdAt",
        "updatedAt",
        "actionGroupState"
      ],
      "members": {
        "agentId": {},
        "agentVersion": {},
        "actionGroupId": {},
        "actionGroupName": {},
        "clientToken": {},
        "description": {},
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        },
        "parentActionSignature": {},
        "actionGroupExecutor": {
          "shape": "S1a"
        },
        "apiSchema": {
          "shape": "S1b"
        },
        "actionGroupState": {}
      }
    },
    "S1k": {
      "type": "list",
      "member": {
        "type": "structure",
        "required": [
          "agentVersion"
        ],
        "members": {
          "agentVersion": {}
        }
      }
    },
    "S1n": {
      "type": "structure",
      "required": [
        "agentId",
        "agentAliasId",
        "agentAliasName",
        "agentAliasArn",
        "routingConfiguration",
        "createdAt",
        "updatedAt",
        "agentAliasStatus"
      ],
      "members": {
        "agentId": {},
        "agentAliasId": {},
        "agentAliasName": {},
        "agentAliasArn": {},
        "clientToken": {},
        "description": {},
        "routingConfiguration": {
          "shape": "S1k"
        },
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        },
        "agentAliasHistoryEvents": {
          "type": "list",
          "member": {
            "type": "structure",
            "members": {
              "routingConfiguration": {
                "shape": "S1k"
              },
              "endDate": {
                "shape": "S9"
              },
              "startDate": {
                "shape": "S9"
              }
            }
          }
        },
        "agentAliasStatus": {}
      }
    },
    "S1u": {
      "type": "structure",
      "required": [
        "type"
      ],
      "members": {
        "type": {},
        "s3Configuration": {
          "type": "structure",
          "required": [
            "bucketArn"
          ],
          "members": {
            "bucketArn": {},
            "inclusionPrefixes": {
              "type": "list",
              "member": {}
            }
          }
        }
      }
    },
    "S20": {
      "type": "structure",
      "members": {
        "kmsKeyArn": {}
      }
    },
    "S21": {
      "type": "structure",
      "members": {
        "chunkingConfiguration": {
          "type": "structure",
          "required": [
            "chunkingStrategy"
          ],
          "members": {
            "chunkingStrategy": {},
            "fixedSizeChunkingConfiguration": {
              "type": "structure",
              "required": [
                "maxTokens",
                "overlapPercentage"
              ],
              "members": {
                "maxTokens": {
                  "type": "integer"
                },
                "overlapPercentage": {
                  "type": "integer"
                }
              }
            }
          }
        }
      }
    },
    "S28": {
      "type": "structure",
      "required": [
        "knowledgeBaseId",
        "dataSourceId",
        "name",
        "status",
        "dataSourceConfiguration",
        "createdAt",
        "updatedAt"
      ],
      "members": {
        "knowledgeBaseId": {},
        "dataSourceId": {},
        "name": {},
        "status": {},
        "description": {},
        "dataSourceConfiguration": {
          "shape": "S1u"
        },
        "serverSideEncryptionConfiguration": {
          "shape": "S20"
        },
        "vectorIngestionConfiguration": {
          "shape": "S21"
        },
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        }
      }
    },
    "S2c": {
      "type": "structure",
      "required": [
        "type"
      ],
      "members": {
        "type": {},
        "vectorKnowledgeBaseConfiguration": {
          "type": "structure",
          "required": [
            "embeddingModelArn"
          ],
          "members": {
            "embeddingModelArn": {}
          }
        }
      }
    },
    "S2g": {
      "type": "structure",
      "required": [
        "type"
      ],
      "members": {
        "type": {},
        "opensearchServerlessConfiguration": {
          "type": "structure",
          "required": [
            "collectionArn",
            "vectorIndexName",
            "fieldMapping"
          ],
          "members": {
            "collectionArn": {},
            "vectorIndexName": {},
            "fieldMapping": {
              "type": "structure",
              "required": [
                "vectorField",
                "textField",
                "metadataField"
              ],
              "members": {
                "vectorField": {},
                "textField": {},
                "metadataField": {}
              }
            }
          }
        },
        "pineconeConfiguration": {
          "type": "structure",
          "required": [
            "connectionString",
            "credentialsSecretArn",
            "fieldMapping"
          ],
          "members": {
            "connectionString": {},
            "credentialsSecretArn": {},
            "namespace": {},
            "fieldMapping": {
              "type": "structure",
              "required": [
                "textField",
                "metadataField"
              ],
              "members": {
                "textField": {},
                "metadataField": {}
              }
            }
          }
        },
        "redisEnterpriseCloudConfiguration": {
          "type": "structure",
          "required": [
            "endpoint",
            "vectorIndexName",
            "credentialsSecretArn",
            "fieldMapping"
          ],
          "members": {
            "endpoint": {},
            "vectorIndexName": {},
            "credentialsSecretArn": {},
            "fieldMapping": {
              "type": "structure",
              "required": [
                "vectorField",
                "textField",
                "metadataField"
              ],
              "members": {
                "vectorField": {},
                "textField": {},
                "metadataField": {}
              }
            }
          }
        },
        "rdsConfiguration": {
          "type": "structure",
          "required": [
            "resourceArn",
            "credentialsSecretArn",
            "databaseName",
            "tableName",
            "fieldMapping"
          ],
          "members": {
            "resourceArn": {},
            "credentialsSecretArn": {},
            "databaseName": {},
            "tableName": {},
            "fieldMapping": {
              "type": "structure",
              "required": [
                "primaryKeyField",
                "vectorField",
                "textField",
                "metadataField"
              ],
              "members": {
                "primaryKeyField": {},
                "vectorField": {},
                "textField": {},
                "metadataField": {}
              }
            }
          }
        }
      }
    },
    "S33": {
      "type": "structure",
      "required": [
        "knowledgeBaseId",
        "name",
        "knowledgeBaseArn",
        "roleArn",
        "knowledgeBaseConfiguration",
        "storageConfiguration",
        "status",
        "createdAt",
        "updatedAt"
      ],
      "members": {
        "knowledgeBaseId": {},
        "name": {},
        "knowledgeBaseArn": {},
        "description": {},
        "roleArn": {},
        "knowledgeBaseConfiguration": {
          "shape": "S2c"
        },
        "storageConfiguration": {
          "shape": "S2g"
        },
        "status": {},
        "createdAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        },
        "failureReasons": {
          "shape": "S14"
        }
      }
    },
    "S41": {
      "type": "structure",
      "required": [
        "knowledgeBaseId",
        "dataSourceId",
        "ingestionJobId",
        "status",
        "startedAt",
        "updatedAt"
      ],
      "members": {
        "knowledgeBaseId": {},
        "dataSourceId": {},
        "ingestionJobId": {},
        "description": {},
        "status": {},
        "statistics": {
          "shape": "S43"
        },
        "failureReasons": {
          "shape": "S14"
        },
        "startedAt": {
          "shape": "S9"
        },
        "updatedAt": {
          "shape": "S9"
        }
      }
    },
    "S43": {
      "type": "structure",
      "members": {
        "numberOfDocumentsScanned": {
          "type": "long"
        },
        "numberOfNewDocumentsIndexed": {
          "type": "long"
        },
        "numberOfModifiedDocumentsIndexed": {
          "type": "long"
        },
        "numberOfDocumentsDeleted": {
          "type": "long"
        },
        "numberOfDocumentsFailed": {
          "type": "long"
        }
      }
    }
  }
}